////////////////////////////////////////////////////////////////////////////////
// The following FIT Protocol software provided may be used with FIT protocol
// devices only and remains the copyrighted property of Garmin Canada Inc.
// The software is being provided on an "as-is" basis and as an accommodation,
// and therefore all warranties, representations, or guarantees of any kind
// (whether express, implied or statutory) including, without limitation,
// warranties of merchantability, non-infringement, or fitness for a particular
// purpose, are specifically disclaimed.
//
// Copyright 2018 Garmin Canada Inc.
////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 20.78Release
// Tag = production/akw/20.78.00-0-gef63ea6
////////////////////////////////////////////////////////////////////////////////


#include <ostream>
#include "fit_developer_field_definition.hpp"
#include "fit_developer_field.hpp"

namespace fit
{

DeveloperFieldDefinition::DeveloperFieldDefinition()
    : num( FIT_FIELD_NUM_INVALID )
    , size( 0 )
    , developerDataIndex( FIT_UINT8_INVALID )
    , mesg( nullptr )
    , developer( nullptr )
{
}

DeveloperFieldDefinition::DeveloperFieldDefinition(const DeveloperFieldDefinition& other)
    : num( other.num )
    , size( other.size )
    , developerDataIndex( other.developerDataIndex )
    , mesg( nullptr )
    , developer( nullptr )
{
    if (nullptr != other.mesg)
    {
        mesg = new FieldDescriptionMesg( *other.mesg );
    }

    if ( nullptr != other.developer )
    {
        developer = new DeveloperDataIdMesg( *other.developer );
    }
}

DeveloperFieldDefinition::DeveloperFieldDefinition(FIT_UINT8 fieldNum, FIT_UINT8 size, FIT_UINT8 developerDataIndex)
    : num( fieldNum )
    , size( size )
    , developerDataIndex( developerDataIndex )
    , mesg( nullptr )
    , developer( nullptr )
{
}

DeveloperFieldDefinition::DeveloperFieldDefinition( const FieldDescriptionMesg& desc, const DeveloperDataIdMesg& developer, FIT_UINT8 size )
    : num( desc.GetFieldDefinitionNumber() )
    , size( size )
    , developerDataIndex( desc.GetDeveloperDataIndex() )
    , mesg( new FieldDescriptionMesg( desc ) )
    , developer( new DeveloperDataIdMesg( developer ) )
{
}

DeveloperFieldDefinition::DeveloperFieldDefinition(const DeveloperField& field)
    : DeveloperFieldDefinition(field.GetDefinition())
{
    size = field.GetSize();
}

DeveloperFieldDefinition::~DeveloperFieldDefinition()
{
    if ( nullptr != mesg )
    {
        delete mesg;
        mesg = nullptr;
    }

    if ( nullptr != developer )
    {
        delete developer;
        developer = nullptr;
    }
}

FIT_BOOL DeveloperFieldDefinition::IsDefined() const
{
    return nullptr != mesg &&
           nullptr != developer;
}

FIT_UINT8 DeveloperFieldDefinition::GetNum() const
{
    return num;
}

FIT_UINT8 DeveloperFieldDefinition::GetSize() const
{
    return size;
}

FIT_UINT8 DeveloperFieldDefinition::GetType() const
{
    if (IsDefined())
    {
        return mesg->GetFitBaseTypeId();
    }

    return FIT_BASE_TYPE_UINT8;
}

FIT_UINT8 DeveloperFieldDefinition::GetDeveloperDataIndex() const
{
    return developerDataIndex;
}

const FieldDescriptionMesg& DeveloperFieldDefinition::GetDescription() const
{
    return *mesg;
}

const DeveloperDataIdMesg& DeveloperFieldDefinition::GetDeveloper() const
{
    return *developer;
}

FIT_BOOL DeveloperFieldDefinition::operator==(const DeveloperFieldDefinition& field) const
{
    if (num != field.num)
        return FIT_FALSE;

    if (developerDataIndex != field.developerDataIndex)
        return FIT_FALSE;

    return FIT_TRUE;
}

FIT_BOOL DeveloperFieldDefinition::operator!=(const DeveloperFieldDefinition& field) const
{
    return !(*this == field);
}

FIT_UINT8 DeveloperFieldDefinition::Write(std::ostream &file) const
{
    file.put(num);
    file.put(size);
    file.put(developerDataIndex);

    return 3;
}

} // namespace fit
